#include <iostream>
#include <vector>

using namespace std;

#define int int64_t
#define MOD 1000000007

int dfs(vector<vector<vector<int>>> &g, int n, int k, int t) // 1 = first = up
{
    //cout << n << " " << k << endl;
    if (n == k)
        return 1;
    if (n < k)
        return 0;
    if (t == 1)
    {
        if (g[n][k][t] > -1)
            return g[n][k][t];
        g[n][k][t] = 0;
        for (int r = k + 1; r <= n - k; ++r)
            g[n][k][t] += dfs(g, n - k, r, 1 - t);
        g[n][k][t] %= MOD;
        return g[n][k][t];
    }
    if (g[n][k][t] > -1)
        return g[n][k][t];
    g[n][k][t] = 0;
    for (int r = 1; r < k && r <= n - k; ++r)
        g[n][k][t] += dfs(g, n - k, r, 1 - t);
    g[n][k][t] %= MOD;
    return g[n][k][t];
}

int32_t main()
{
    int n, k;
    cin >> n >> k;
    if (n == k)
    {
        cout << 1 << endl;
        return 0;
    }
    vector<vector<vector<int>>> g(n + 1, vector<vector<int>>(k + 1, vector<int>(2, -1)));
    cout << (dfs(g, n, k, 0) + dfs(g, n, k, 1)) % MOD << endl;
    return 0;
}
