#include <iostream>
#include <vector>

using namespace std;

#define int int64_t
#define MOD 1000000007

int dfs(vector<vector<pair<int, int> > > &g, int n, int k, bool t) // 1 = first = up
{
    cout << n << " " << k << endl;
    if (n == k)
        return 1;
    if (n < k)
        return 0;
    if (t == 1)
    {
        if (g[n][k].first != 0)
            return g[n][k].first;
        for (int r = k + 1; r <= n - k; ++r)
            g[n][k].first += dfs(g, n - k, r, !t);
        g[n][k].first %= MOD;
        return g[n][k].first;
    }
    if (g[n][k].second != 0)
        return (g[n][k]).second;
    for (int r = 1; r < k && r <= n - k; ++r)
        g[n][k].second += dfs(g, n - k, r, !t);
    g[n][k].second %= MOD;
    return g[n][k].second;
}

int32_t main()
{
    int n, k;
    cin >> n >> k;
    if (n == k)
    {
        cout << 1;
        return 0;
    }
    vector<vector<pair<int, int> > > g(n + 1, vector<pair<int, int> >(k + 1, make_pair(0, 0)));
    cout << (dfs(g, n, k, 0) + dfs(g, n, k, 1)) % MOD;
    return 0;
}
